; C:\masm32\SOURCE\test.asm(196) : error A2070: invalid instruction operands
.586
.model flat, stdcall
option casemap:none

include \masm32\include\windows.inc
    include \masm32\include\user32.inc
    include \masm32\include\kernel32.inc
    include \masm32\include\advapi32.inc
    include \masm32\include\shlwapi.inc
    include \masm32\macros\macros.asm

    includelib  \masm32\lib\kernel32.lib
    includelib  \masm32\lib\user32.lib
    includelib  \masm32\lib\advapi32.lib
    includelib  \masm32\lib\shlwapi.lib 

CTEXT MACRO y:VARARG
	LOCAL sym

	CONST segment
		IFIDNI <y>,<>
			sym db 0
		ELSE
			sym db y,0
		ENDIF
	CONST ends

	EXITM <OFFSET sym>
ENDM

skip_arg proto pString:DWORD

CR equ 13
LF equ 10

.data

usage           db "Time_FF",CR,LF
                db "Prints the execution time of a process.",CR,LF
                db "Usage: Time_FF  <program> [<program-parameters>]",CR,LF

len_usage   equ $ - OFFSET usage+1

errCreate   db "Failed to start the process.",CR,LF,0

result      db "Time Firefox was open -> %lu milliseconds",CR,LF,0 
                                 ; user:%lums kern:%lums",CR,LF,0

.data?

hStdOut     HANDLE  ?
hStdErr     HANDLE  ?
chWritten   DWORD   ?

stInfo      STARTUPINFO <?>
procInfo    PROCESS_INFORMATION <?>

timeSt      FILETIME <?>
timeEnd     FILETIME <?>
timeKernel  FILETIME <?>
timeUser    FILETIME <?>

buff        db 64 dup (?)

.code

start:
    invoke GetStdHandle, STD_OUTPUT_HANDLE
    mov hStdOut,eax
    invoke GetStdHandle, STD_ERROR_HANDLE
    mov hStdErr,eax

    push esi
    invoke GetCommandLine
    mov esi,eax
    invoke skip_arg, eax   ;first arg is this program's name, we want everything 
                           ;after it

 ;;what to do with pipes - should it redirect from timit, the invoked process, or both??
    .IF (eax != -1)
        push ebx
        add esi,eax

        mov ebx,OFFSET stInfo
        assume ebx:ptr STARTUPINFO
        xor eax,eax
        mov [ebx].cb,SIZEOF stInfo
        mov [ebx].lpReserved,eax
        mov [ebx].lpDesktop,eax
        mov [ebx].lpTitle,eax
        mov [ebx].dwFlags,eax
        mov DWORD PTR [ebx].wShowWindow,eax   ;also zeroes 'cbReserved2'
        mov [ebx].lpReserved2,eax
        assume edx:nothing

        invoke CreateProcess, eax,esi,eax,eax,TRUE,eax,eax,eax,ebx,ADDR procInfo
        .IF (eax)

            mov ebx,[procInfo.hProcess]
            invoke WaitForSingleObject, ebx,-1
            invoke GetProcessTimes, ebx,ADDR timeSt,ADDR timeEnd,ADDR timeKernel,ADDR timeUser

            ; These divsions could overflow -- if result is >= 2^32; but 2^32 ms is
            ; actually 49.71 days 

            mov ecx,10000

             ; ;kernel time (in milliseconds)
              mov eax,[timeKernel.dwLowDateTime]
              mov edx,[timeKernel.dwHighDateTime]
              ;convert to milliseconds
              add eax,5000    ;(so division rounds up)
              adc edx,0
              div ecx
              push eax
  
              ;user time
              mov eax,[timeUser.dwLowDateTime]
              mov edx,[timeUser.dwHighDateTime]
              add eax,5000
              adc edx,0
              div ecx
              push eax

            ; execution time = (timeEnd - timeSt)
            ; seconds = milliseconds/1000
            ; minutes = seconds/60
            ; hours = minutes/60
            ; days = hours/24 

; 1. Take total time.
; 2. Divide by 3600000 : Quotient = Hours    (60 min * 60 sec * 1000 milliseconds)


             ; xor edx,edx    ; convert to seconds
             ; xor ebx,ebx
             ; mov ebx,1000d  ; divide by 1000 
             ; div ebx  
             ;int 3 


            mov eax,[timeEnd.dwLowDateTime]
            mov edx,[timeEnd.dwHighDateTime]
            sub eax,[timeSt.dwLowDateTime]
            sbb edx,[timeSt.dwHighDateTime]
            mov ecx,10000
            add eax,5000
            adc edx,0
            div ecx
            push eax ; results is in milliseconds

            push OFFSET result
            push OFFSET buff
            call wsprintf
            add esp,(4*5)

invoke CreateFile,CTEXT("result.txt"), GENERIC_WRITE, FILE_SHARE_READ or FILE_SHARE_WRITE, \
				0, OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, 0
	.IF (eax==INVALID_HANDLE_VALUE)
		invoke	MessageBox, 0, CTEXT("Error!"), CTEXT("Can't create file"), MB_OK
		invoke	ExitProcess, -1
	.ENDIF

; file handle is saved in EBX, since that's one of the registers that aren't trashed by
; API calls. SIZEOF is used instead of strlen, since SIZEOF is done at assemble-time instead
; of a runtime call to lstrlen.

	mov		ebx, eax
	invoke	WriteFile, ebx, ADDR buff,eax,ADDR chWritten,NULL 
	
	invoke	CloseHandle, ebx



        .ELSE
            invoke WriteFile, hStdErr,ADDR errCreate,SIZEOF errCreate-1,ADDR chWritten,NULL
        .ENDIF
        pop ebx
    .ELSE



 invoke WriteFile, hStdErr,ADDR usage,len_usage-1,ADDR chWritten,NULL
       

    .ENDIF
    pop esi
    invoke ExitProcess, NULL

;***************************************************************************************************

skip_arg proc pString:DWORD
    push esi
    mov esi,pString
    xor eax,eax
    xor ecx,ecx

    ;skip any initial whitespace
  @@:
    mov al,[esi+ecx]
    add ecx,1
    cmp al,' '      ;SPACE
    je @B
    cmp al,9        ;TAB
    je @B

    ;may start with a quote
    cmp al,'"'      ;QUOTE
    je @qt

    ;find end of argument
  @@:
    cmp al,' '      ;SPACE
    je @tail
    cmp al,9        ;TAB
    je @tail
    test al,al      ;end of string
    jz @fail
    mov al,[esi+ecx]
    add ecx,1
    jmp @B

  @qt:
    ;skip until closing quote
    mov al,[esi+ecx]
    add ecx,1
    test al,al
    jz @fail
    cmp al,'"'      ;QUOTE
    jne @qt

  @tail:
    ;skip any trailing whitespace
    mov al,[esi+ecx]
    add ecx,1
    cmp al,' '      ;SPACE
    je @tail
    cmp al,9        ;TAB
    je @tail
    test al,al      ;end of string
    jz @fail

    sub ecx,1
    mov eax,ecx
    pop esi
    ret

  @fail:
    mov eax,-1
    pop esi
    ret
skip_arg endp

end start
